"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const xlib = tslib_1.__importStar(require("xlib"));
//import { fs } from "mz";
// tslint:disable-next-line: no-submodule-imports
tslib_1.__exportStar(require("mz/fs"), exports);
const glob = tslib_1.__importStar(require("glob"));
//export { glob };
const os_fs = tslib_1.__importStar(require("fs"));
exports.path = require("path");
/** find files.  internally uses https://www.npmjs.com/package/glob */
function find(pattern, options) {
    return new Promise((resolve, reject) => {
        glob.default(pattern, options, (err, files) => {
            if (err) {
                reject(err);
                return;
            }
            if (options && options.disableNormalization === true) {
                resolve(files);
                return;
            }
            const normalizedFiles = files.map(exports.path.normalize);
            resolve(normalizedFiles);
            return;
        });
    });
}
exports.find = find;
const pathSep = exports.path.sep;
/** mkdir recursively */
const _mkdirp = tslib_1.__importStar(require("mkdirp"));
/** Create each supplied directory including any necessary parent directories that don't yet exist..   internally uses https://www.npmjs.com/package/mkdirp
    * @returns  first directory made that had to be created, if any.
    @throws fs error if any encountered
*/
async function mkdir_recursive(pathToCreate, 
/** If a directory needs to be created, set the mode as an octal permission string or number */
mode) {
    const mkdirOptions = {
        mode,
        fs: {
            mkdir: os_fs.mkdir,
            stat: os_fs.stat,
        }
    };
    return new xlib.promise.bluebird((resolve, reject) => {
        _mkdirp.default(pathToCreate, mkdirOptions, (err, made) => {
            if (err != null) {
                reject(err);
            }
            else {
                resolve(made);
            }
            return;
        });
    });
}
exports.mkdir_recursive = mkdir_recursive;
/** delete files and folders using globs and promises.  https://www.npmjs.com/package/del */
exports.del = require("del");
// import * as _del from "del";
// export { del };
// import xx = require( "xlib" );
// xx.
// del()
// /** delete dir recursively */
// import * as rimraf from "rimraf";
// export function rmDirRecursiveAsync( path ): Promise<void> {
// 	var args = <any[]><any>arguments;
// 	return ( <any>Promise ).fromNode( ( cb ) => {
// 		return xlib.jsHelper.apply( rimraf, rimraf, args, null, [ cb ] );
// 	} );
// }
// }
// export function mkDirRecursiveAsync( path ): Promise<void> {
// 	var args = <any[]><any>arguments;
// 	return ( <any>Promise ).fromNode( ( cb ) => {
// 		return xlib.jsHelper.apply( mkdirp, mkdirp, args, null, [ cb ] );
// 	} );
// }
//# sourceMappingURL=fs.js.map