"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const xlib = tslib_1.__importStar(require("xlib"));
const mz_1 = require("mz");
exports.fs = mz_1.fs;
const glob = tslib_1.__importStar(require("glob"));
exports.glob = glob;
exports.path = require("path");
/** find files.  internally uses https://www.npmjs.com/package/glob */
function find(pattern, options) {
    return new Promise((resolve, reject) => {
        glob.default(pattern, options, (err, files) => {
            if (err) {
                reject(err);
                return;
            }
            if (options && options.disableNormalization === true) {
                resolve(files);
                return;
            }
            const normalizedFiles = files.map(exports.path.normalize);
            resolve(normalizedFiles);
            return;
        });
    });
}
exports.find = find;
const pathSep = exports.path.sep;
/** mkdir recursively */
const mkdirp = tslib_1.__importStar(require("mkdirp"));
/** Create each supplied directory including any necessary parent directories that don't yet exist..   internally uses https://www.npmjs.com/package/mkdirp
    * @returns  first directory made that had to be created, if any.
    @throws fs error if any encountered
*/
async function mkdir(pathToCreate, 
/** If a directory needs to be created, set the mode as an octal permission string or number */
mode) {
    const mkdirOptions = {
        mode,
        fs: {
            mkdir: mz_1.fs.mkdir,
            stat: mz_1.fs.stat,
        }
    };
    return new xlib.promise.bluebird((resolve, reject) => {
        mkdirp.default(pathToCreate, mkdirOptions, (err, made) => {
            if (err != null) {
                reject(err);
            }
            else {
                resolve(made);
            }
            return;
        });
    });
}
exports.mkdir = mkdir;
const del = tslib_1.__importStar(require("del"));
exports.del = del;
// del()
// /** delete dir recursively */
// import * as rimraf from "rimraf";
// export function rmDirRecursiveAsync( path ): Promise<void> {
// 	var args = <any[]><any>arguments;
// 	return ( <any>Promise ).fromNode( ( cb ) => {
// 		return xlib.jsHelper.apply( rimraf, rimraf, args, null, [ cb ] );
// 	} );
// }
// }
// export function mkDirRecursiveAsync( path ): Promise<void> {
// 	var args = <any[]><any>arguments;
// 	return ( <any>Promise ).fromNode( ( cb ) => {
// 		return xlib.jsHelper.apply( mkdirp, mkdirp, args, null, [ cb ] );
// 	} );
// }
//# sourceMappingURL=io.js.map