export interface IValidityResult {
    isValid: boolean;
    reason?: "email, invalid address" | "email, disposable domain" | "email, disposable domain via mxRecord" | "email, invalid mxRecord";
    details?: string;
}
/** returns a report on the validity of the email address (if MX records exist, if the domain is a disposable) */
export declare function isEmailValid(email: string, options?: {
    /** set to true to check if valid mxRecords exist, and also checks the mxRecord against known disposable email providers.
     * default FALSE because this is pretty slow (100ms) but we cache mxRecords found for 30 minutes to accelerate further requests of same domain */
    checkMx?: boolean;
}): Promise<IValidityResult>;
//# sourceMappingURL=validation.d.ts.map